//  Copyright 2016 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart-ext:dna';
import 'dart:typed_data';

int createCallVM(int size) native "createCallVM";
void freeCallVM(int vm) native "freeCallVM";

int loadLibrary(String name) native "loadLibrary";
void freeLibrary(int lib) native "freeLibrary";
int findSymbol(int lib, String name) native "findSymbol";

void pushParameters(int vm, List<int> types, List<Object> args)
    native "pushParameters";
dynamic callFunction(int vm, int pointer, int returnType) native "callFunction";

List<int> getSizes() native "getSizes";
int getPointer(TypedData data) native "getPointer";
