//  Copyright 2016 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart:math';

import 'types.dart';
import 'util_c.dart';

class Sizes {
  int offset = 0;
  int totalSize = 0;
  int maxSize = 0;

  int _fixSize(int size) {
    return (size > ctypeToSize(C_POINTER) || size == 0) ? 1 : size; 
  }

  void alignField(int size) {
    var padding = align(offset, _fixSize(size));
    offset += padding;
    totalSize += padding;
  }

  void alignByMax() {
    alignField(maxSize);
  }

  void addField(int size) {
    offset += size;
    totalSize += size;    
    maxSize = min(max(size, maxSize), ctypeToSize(C_POINTER));
  }

  void addStruct(int size, int maxSize) {
    offset += size;
    totalSize += size;
    maxSize = min(max(size, maxSize), ctypeToSize(C_POINTER));
  }
}