//  Copyright 2016 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart:mirrors';

List<MethodMirror> findMethods(ClassMirror classMirror, Symbol name) {
  var methods = classMirror.declarations.values
      .where((e) => e.simpleName == name)
      .where((e) => e is MethodMirror)
      .map((e) => e as MethodMirror)
      .toList();
  return methods;
}

InstanceMirror findTag(DeclarationMirror mirror, Type t) {
  var tag = mirror.metadata.where((e) => e.type == reflectClass(t)).toList();
  return tag.isNotEmpty ? tag[0] : null;
}

List<DeclarationMirror> findDeclarations(TypeMirror typeMirror) {
  ClassMirror classMirror = typeMirror as ClassMirror;
  return classMirror.declarations.values.toList();
}